#include <bits/stdc++.h>

using namespace std;

#define MAXN 40000
#define MAXQ 40000

FILE *fr, *fw;


void set_value_min(vector<int>& tree, int k, int val) {
    k += tree.size() / 2;
    tree[k] = val;
    for(k /= 2; k >= 1; k /= 2) tree[k] = min(tree[2*k], tree[2*k+1]);
}

void segment_tree_min(int array[], int N, vector<int>& tree) {
    int size = 1;
    while(size < N) size *= 2;
    tree.resize(size * 2);
    for(int i = 0; i < N; i++) set_value_min(tree, i, array[i]);
}

int minq(const vector<int>& tree, int a, int b) {
    a += tree.size() / 2;
    b += tree.size() / 2;
    int res = INT_MAX;
    for(; a <= b; a /= 2, b /= 2) {
        if(a % 2 == 1) res = min(res, tree[a++]);
        if(b % 2 == 0) res = min(res, tree[b--]);
    }
    return res;
}


void set_value_max(vector<int>& tree, int k, int val) {
    k += tree.size() / 2;
    tree[k] = val;
    for(k /= 2; k >= 1; k /= 2) tree[k] = max(tree[2*k], tree[2*k+1]);
}

void segment_tree_max(int array[], int N, vector<int>& tree) {
    int size = 1;
    while(size < N) size *= 2;
    tree.resize(size * 2);
    for(int i = 0; i < N; i++) set_value_max(tree, i, array[i]);
}

int maxq(const vector<int>& tree, int a, int b) {
    a += tree.size() / 2;
    b += tree.size() / 2;
    int res = INT_MIN;
    for(; a <= b; a /= 2, b /= 2) {
        if(a % 2 == 1) res = max(res, tree[a++]);
        if(b % 2 == 0) res = max(res, tree[b--]);
    }
    return res;
}


void info(int mn, int mx) {
    fprintf(fw, "%d %d\n", mn, mx);
}

void win(int N, int W[], int Q, int K[]) {
    vector<int> tree_min, tree_max;
    segment_tree_min(W, 2*N, tree_min);
    segment_tree_max(W, 2*N, tree_max);
    
    for(int i = 0, start = 0; i < Q; i++) {
        start -= K[i];
        if(start < 0) start += 2*N;
        if(start < N) {
            int a = minq(tree_min, start, start + N - 1);
            int b = maxq(tree_max, start + N, 2*N - 1);
            int c = maxq(tree_max, 0, start - 1);
            info(a, max(b,c));
        }
        else {
            int a = minq(tree_min, start, 2*N - 1);
            int b = minq(tree_min, 0, start - N - 1);
            int c = maxq(tree_max, start - N, start - 1);
            info(min(a,b), c);
        }
    }
}


int W[2*MAXN];
int K[MAXN];

int main() {
    int N, Q, i;

    fr = fopen("input.txt", "r");
    fw = fopen("output.txt", "w");
    assert(1 == fscanf(fr, "%d", &N));
    for(i=0; i<2*N; i++)
        assert(1 == fscanf(fr, "%d", &W[i]));
    assert(1 == fscanf(fr, "%d", &Q));
    for(i=0; i<Q; i++)
        assert(1 == fscanf(fr, "%d", &K[i]));

    win(N, W, Q, K);
    fclose(fr);
    fclose(fw);
    return 0;
}
